#!/usr/bin/perl

use strict;
use warnings;

if(@ARGV < 2) { die "usage: $0 folder (folder in which the find is done) get_folder (0|1)\nperl $0 /data/matti/VTT/GOLM_MAP/KEGG/pathway 0\n"; }
&main($ARGV[0], $ARGV[1]);

#########################################################################################################
#read parameters
sub main {
	my($folder, $get_folder)		= @_;
	my($line)				= "";
	my(@cols)				= ();
	my(@file_list)				= ();
	my($file_ext)				= "";
	my(%cpd_map_hash)			= ();
	my(%maps)				= ();
	my(%cpds)				= ();
	my($this_map)				= "";
	my($this_cpd)				= "";
	my($print_line)				= "";

	if($get_folder eq '1') {
		system("wget -r --accept \'*.list\' \'ftp://ftp.genome.jp/pub/kegg/pathway/organisms/\' -o recuresive_wget.logi -nd --directory-prefix \'$folder\'") or die "wget failed\n";
	}

	open(FIND, "find \'$folder\' -name \'*.list\' -maxdepth 2|");
	@file_list = <FIND>;
	close FIND;

	print STDERR "found ".scalar(@file_list)." map-folder\n\n";

	#read list.files
	for(my($i) = 0; $i < @file_list; ++$i) {
		if(($i % 500 == 0) && ($i != 0))        { print STDERR "//50\n"; }
		if($i % 10 == 0)			{ print STDERR "*"; }

		$file_ext = $file_list[$i];
		$file_ext =~ s/^.*\///g;
		$file_ext =~ s/\.list//g;
		$file_ext =~ s/^\s+|\s+$//g;
		
		open(IN, $file_list[$i]) or die "$file_list[$i] not found\n";
		while($line = <IN>) {
			$line =~ s/^\s+|\s+$//g;
			if(($line =~ m/path:/i ) && ($line =~ m/cpd:/i)) {
				@cols 	= split(/\s+/, $line);
				%maps 	= ();
				%cpds	= ();
				for(my($j) = 0; $j < @cols; ++$j) {
					if($cols[$j] =~ m/path:/) {
						$maps{$cols[$j]} = 1;	
					}
					if($cols[$j] =~ m/cpd:/) {
						$cpds{$cols[$j]} = 1;
					}
				}

				#store all map-compound associations (organism specifically)
				for my $key1 (keys(%cpds)) {
					$this_cpd	= $key1;
					$this_cpd	=~ s/cpd://g;
					for my $key2 (keys(%maps)) {
						$this_map	=  $key2;
						$this_map	=~ s/path://g;
						$this_map	=~ s/$file_ext/map/g;
						$cpd_map_hash{$this_cpd}{$file_ext}{$this_map} = 0;
					}
				}

			}
		}		
		close IN;
	}
	print STDERR "\n";
	print STDERR "printing results\n";	

	#print list.files
	for my $key1 (keys(%cpd_map_hash)) {
		for my $key2 (keys( %{$cpd_map_hash{$key1}} )) {
			$print_line = "$key1\tno_enzyme_listing\t".uc($key2)."\t";
			for my $key3 (keys( %{$cpd_map_hash{$key1}{$key2}} )) {
				$print_line .= "$key3,";
			}
			$print_line =~ s/\s+$//g;
			$print_line =~ s/,$//g;
			$print_line =~ s/,,/,/g;
			print "$print_line\n";
		}

	}

};
#########################################################################################################

