#!/usr/bin/perl

use strict;
use warnings;

if(@ARGV < 4) { die "usage: $0 cpd_map_org.tab (KEGG-list) map_title.tab (KEGG-map)  metabolite_mapping.csv (SMPDB) prefix\n"; }
&main($ARGV[0], $ARGV[1], $ARGV[2], $ARGV[3]);

#########################################################################################################
#read parameters
sub main {
	my($addfile, $mapfile, $smpdbfile, $prefix)		= @_;
	my($line)						= "";
	my(@cols)						= ();
	my($pathway)						= "";
	my(%smpdb)						= ();
	my(%smpdbmaps)						= ();
	my($quote_string)					= "";
	my($quote_string_new)					= "";	
	my($new_line)						= "";

	open(IN, $smpdbfile) or die "SMPDB-file $smpdbfile not found\n";
	while($line = <IN>) {
		$new_line = $line;
		while($line =~ m/\".*?\"/g) {
			$quote_string 		= $&;
			$quote_string_new	= $&;
			$quote_string_new	=~ s/\,/\/g;
			$new_line =~ s/$quote_string/$quote_string_new/g;
		}
		
		@cols 		= split(/,/, $new_line);
		$cols[1]	=~ s/\/,/g;
		$cols[1] 	=~ s/\s+/_/g; 
		$cols[1]	=~ s/[\"\']//g;
		$pathway 	= "smpdb_".lc($cols[1]);
		$cols[4]	=~ s/\/,/g;
		if(length($cols[4])) {
			$smpdb{$cols[4]}{"map$cols[0]"} = 1;
			$smpdbmaps{$cols[0]} = $cols[1];
		} else {
			$new_line =~ s/^\s+|\s+$//g;
			#print STDERR "NO KEGG: $new_line\n";
		}
		#print STDERR "$cols[4]| $pathway\n";
	}
	close IN;

        open(IN, $mapfile) or die "KEGG-mapfile $mapfile not found\n";
	open(OUT, ">$prefix.map") or die "KEGG-map outfile $prefix.map not found\n";
        while($line = <IN>) {
                $line  =~ s/^\s+|\s+$//g;
		print OUT "$line\n";
	}
	close IN;
	for my $key (keys(%smpdbmaps)) {
		print OUT "$key\t$smpdbmaps{$key}\n";
	}
	close OUT;

	open(IN, $addfile) or die "KEGG-file $addfile not found\n";
	open(OUT, ">$prefix.tab") or die "KEGG-map outfile $prefix.tab not found\n";
	while($line = <IN>) {
		$line  =~ s/^\s+|\s+$//g;
		@cols  = split(/\t/, $line);
		if(exists($smpdb{$cols[0]})) {
			print OUT "$line";
			for my $key (keys(%{$smpdb{$cols[0]}})) {
				print OUT ",$key";
			}
			print OUT "\n";
		} else {
			print OUT "$line\n";
		}
	}
	close IN;
	close OUT;
}
#########################################################################################################
